"use strict";

this.name        = "Gunsight Configuration";
this.author      = "Wildeblood";
this.copyright   = "(C)2011, Wildeblood"; // All rights reserved. Free to use, but DO NOT PROMULGATE MODIFIED VERSIONS.
this.description = "Wildefire Systems Type 1D Gunsight, configuration thereof";
this.version     = "2.0.3";

this.sizeMode = 1; // 1 to step up small to larger, 2 to step down large to smaller.

this.activated = function(equipmentKey)
	{
	if(player.ship.equipmentStatus("EQ_SNIPER_SCOPE") === "EQUIPMENT_OK")
		{
		switch(this.equipmentKey)
			{
			case "EQ_TARGET_SCOPE_CONFIG_CENTRE":
			case "EQ_TARGET_SCOPE_CONFIG_CENTRE_COLOUR":

				if(missionVariables.sniperScope_Centre === null)	 missionVariables.sniperScope_Centre = 0;
				if(!missionVariables.sniperScope_nextCentre) missionVariables.sniperScope_nextCentre = 1;
				if((missionVariables.sniperScope_Centre < 7) && (missionVariables.sniperScope_Centre > 0))
					{
					player.ship.removeEquipment("EQ_TARGET_SCOPE_PIP_" + missionVariables.sniperScope_CentreColour + missionVariables.sniperScope_Centre);
					}
				switch(this.equipmentKey)
					{
					case "EQ_TARGET_SCOPE_CONFIG_CENTRE": // Increment or decrement the size.

						if(missionVariables.sniperScope_Centre === 0) missionVariables.sniperScope_nextCentre = 1;  // Lower limit, start stepping up.
						if(missionVariables.sniperScope_Centre === 7) missionVariables.sniperScope_nextCentre = -1; // Upper limit, start stepping down.
						missionVariables.sniperScope_Centre += missionVariables.sniperScope_nextCentre;
						break;

					case "EQ_TARGET_SCOPE_CONFIG_CENTRE_COLOUR": // Flip the colour.

						if(missionVariables.sniperScope_CentreColour !== "G") missionVariables.sniperScope_CentreColour = "G";
						else missionVariables.sniperScope_CentreColour = "Y";

						player.ship.removeEquipment(worldScripts["Sniper Sight"].sniperScope_currentHold);
						worldScripts["Sniper Sight"].sniperScope_currentHold = ("EQ_TARGET_SCOPE_HOLD_" + missionVariables.sniperScope_CentreColour); 
						if (worldScripts["Sniper Sight"].sniperScope_currentState === "ON_HOLD") player.ship.awardEquipment(worldScripts["Sniper Sight"].sniperScope_currentHold);
						break;
					}
				if((missionVariables.sniperScope_Centre < 7) && (missionVariables.sniperScope_Centre > 0))
					{
					player.ship.awardEquipment("EQ_TARGET_SCOPE_PIP_" + missionVariables.sniperScope_CentreColour + missionVariables.sniperScope_Centre);
					}
				return;

			case "EQ_TARGET_SCOPE_CONFIG_CONTRAST":

				if(!missionVariables.sniperScope_nextContrast) missionVariables.sniperScope_nextContrast = 1;
				if(worldScripts["Sniper Sight"].sniperScope_Contrast === 0) missionVariables.sniperScope_nextContrast = 1;  // Lower limit, start stepping up.
				if(worldScripts["Sniper Sight"].sniperScope_Contrast === 5) missionVariables.sniperScope_nextContrast = -1; // Upper limit, start stepping down.
				worldScripts["Sniper Sight"].sniperScope_Contrast += missionVariables.sniperScope_nextContrast;

				worldScripts["Sniper Sight"].sniper_hud = "sniper-hud-contrast-" + worldScripts["Sniper Sight"].sniperScope_Contrast + ".plist";

				switch(worldScripts["Sniper Sight"].sniperScope_Contrast)
					{
					case 0: player.consoleMessage("Gunsight contraster is off.",2);           break;
					case 1: player.consoleMessage("Gunsight contrast set to low.",2);         break;
					case 2: player.consoleMessage("Gunsight contrast set to medium low.",2);  break;
					case 3: player.consoleMessage("Gunsight contrast set to medium.",2);      break;
					case 4: player.consoleMessage("Gunsight contrast set to medium high.",2); break;
					case 5: player.consoleMessage("Gunsight contrast set to high.",2);        break;
					}
				// Now for some voodoo:
				this.backup_switchback_hud = worldScripts["Sniper Sight"].switchback_hud;
				player.ship.hud = worldScripts["Sniper Sight"].sniper_hud;
				worldScripts["Sniper Sight"].switchback_hud = this.backup_switchback_hud;
				delete this.backup_switchback_hud;
				return;

			case "EQ_TARGET_SCOPE_CONFIG_GLOW":
			case "EQ_TARGET_SCOPE_CONFIG_OPACITY":
			case "EQ_TARGET_SCOPE_CONFIG_SIZE":

				if(worldScripts["Sniper Sight"].sniperScope_currentState === "ON_TARGET")
					{player.consoleMessage("Move gunsight off target before adjusting this setting.",6); return;}

				if (missionVariables.sniperScope_Size === null) missionVariables.sniperScope_Size = 4;
				if (missionVariables.sniperScope_Opacity === null) missionVariables.sniperScope_Opacity = 4;
				player.ship.removeEquipment(worldScripts["Sniper Sight"].sniperScope_currentSight);
				switch(this.equipmentKey)
					{
					case "EQ_TARGET_SCOPE_CONFIG_SIZE":
						switch(this.sizeMode)
							{
							case 1:
								missionVariables.sniperScope_Size++;
								if(missionVariables.sniperScope_Size > 6) missionVariables.sniperScope_Size = 0; // Upper limit, reset to smallest.
								break;
							case 2:
								missionVariables.sniperScope_Size--;
								if(missionVariables.sniperScope_Size < 0) missionVariables.sniperScope_Size = 6; // Lower limit, reset to largest.
								break;
							}
						break;

					case "EQ_TARGET_SCOPE_CONFIG_OPACITY":
						missionVariables.sniperScope_Opacity++;
						if(missionVariables.sniperScope_Opacity > 5) missionVariables.sniperScope_Opacity = 3; // Upper limit, reset to smallest.
						switch(missionVariables.sniperScope_Opacity)
							{
							case 3: player.consoleMessage("Gunsight set to 33% opacity.",2); break;
							case 4: player.consoleMessage("Gunsight set to 40% opacity.",2); break;
							case 5: player.consoleMessage("Gunsight set to 50% opacity.",2); break;
							}
						break;

					case "EQ_TARGET_SCOPE_CONFIG_GLOW":
						missionVariables.sniperScope_Glow++;
						if(missionVariables.sniperScope_Glow > 9) missionVariables.sniperScope_Glow = 7; // Upper limit, reset to smallest.
						switch(missionVariables.sniperScope_Glow)
							{
							case 7: player.consoleMessage("Gunsight will glow yellow when on target.",3); break;
							case 8: player.consoleMessage("Gunsight will glow green when on target.",3); break;
							case 9: player.consoleMessage("Gunsight will glow red when on target.",3);   break;
							}
						break;
					}
				worldScripts["Sniper Sight"].sniperScope_currentSight = ("EQ_TARGET_SCOPE_" + missionVariables.sniperScope_Size + "_" + missionVariables.sniperScope_Opacity);
				worldScripts["Sniper Sight"].sniperScope_currentGlow = ("EQ_TARGET_SCOPE_" + missionVariables.sniperScope_Size + "_" + missionVariables.sniperScope_Glow);
				player.ship.awardEquipment(worldScripts["Sniper Sight"].sniperScope_currentSight);
				return;

			case "EQ_TARGET_SCOPE_CONFIG_MENU_ON":
				player.ship.removeEquipment("EQ_TARGET_SCOPE_CONFIG_MENU_ON");
				// Remove the equipment just activated, and add the menu.
				worldScripts["Sniper Sight"].sniperScope_showMenu();
				worldScripts["Sniper Sight"].sniperScope_menuState = "MENU_SHOWN";
				// Let the player know what has changed.
				player.consoleMessage("Gunsight customization menu on.",3);
				return;

			case "EQ_TARGET_SCOPE_CONFIG_MENU_OFF":
				worldScripts["Sniper Sight"].sniperScope_hideMenu();
				// After removing the menu, replace the option to enter menu.
				player.ship.awardEquipment("EQ_TARGET_SCOPE_CONFIG_MENU_ON");
				worldScripts["Sniper Sight"].sniperScope_menuState = "MENU_HIDDEN";
				// Let the player know what has changed.
				player.consoleMessage("Gunsight configuration locked.",3);
				return;

			case "EQ_TARGET_SCOPE_CONFIG_MODE":
				if(worldScripts["Sniper Sight"].sniperScope_Mode !== "HOLD")
					{
					worldScripts["Sniper Sight"].sniperScope_Mode = "HOLD";
					player.consoleMessage("Gunsight will hold to acquire a new target.",3);
					}
				else
					{
					worldScripts["Sniper Sight"].sniperScope_Mode = "RELEASE";
					player.consoleMessage("Gunsight will automatically release if target is lost.",3);
					}
				return;

			case "EQ_TARGET_SCOPE_CONFIG_RETICLE":
				if(player.ship.equipmentStatus("EQ_TARGET_SCOPE_RETICLE") !== "EQUIPMENT_OK")
					{
					player.ship.awardEquipment("EQ_TARGET_SCOPE_RETICLE");
					}
				else
					{
					player.ship.removeEquipment("EQ_TARGET_SCOPE_RETICLE");
					}
				return;

			case "EQ_TARGET_SCOPE_CONFIG_CAMERA":
				if(worldScripts["Sniper Sight"].sniperScope_Camera === "ON")
					{
					worldScripts["Sniper Sight"].sniperScope_Camera = "OFF";
					player.consoleMessage("Gunsight camera disabled.",3);
					}
				else
					{
					worldScripts["Sniper Sight"].sniperScope_Camera = "ON";
					player.consoleMessage("Gunsight camera is on.",3);
					}
				return;

			case "EQ_TARGET_SCOPE_CONFIG_SENSITIVITY":
				worldScripts["Sniper Sight"].sniperScope_Sensitivity ++;
				if(worldScripts["Sniper Sight"].sniperScope_Sensitivity > 5)
							{
							worldScripts["Sniper Sight"].sniperScope_Sensitivity = 1;
							}
				player.consoleMessage("Gunsight sensitivity: " + worldScripts["Sniper Sight"].sniperScope_Sensitivity + ".",3);
				return;

	 		default: // This should never happen.
				log(this.name, "was activated by unknown equipment " + this.equipmentKey + ".");
				return;
			}
		}
	else player.consoleMessage("Gunsight damaged.",6);
	}
